package cn.com.qmth.examcloud.support.cache;

import cn.com.qmth.examcloud.support.cache.bean.AppCacheBean;
import cn.com.qmth.examcloud.support.cache.bean.SysPropertyCacheBean;
import cn.com.qmth.examcloud.web.redis.RedisClient;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;

public class CacheHelper {

	private static RedisClient redisClient;

	private static CacheObjectTrigger cacheObjectTrigger;

	private static RedisClient getRedisClient() {
		if (null == redisClient) {
			redisClient = SpringContextHolder.getBean(RedisClient.class);
		}
		return redisClient;
	}

	private static CacheObjectTrigger getCacheObjectTrigger() {
		if (null == cacheObjectTrigger) {
			cacheObjectTrigger = SpringContextHolder.getBean(CacheObjectTrigger.class);
		}
		return cacheObjectTrigger;
	}

	public static AppCacheBean getApp(Long appId) {
		String key = "$_APP:" + appId;
		return getRedisClient().get(key, AppCacheBean.class);
	}

	/**
	 * 获取系统属性<br>
	 *
	 * @author WANGWEI
	 * @param propKey
	 * @return
	 */
	public static SysPropertyCacheBean getSysProperty(String propKey) {
		String key = "$_SYS_PROP:" + propKey;
		SysPropertyCacheBean sysPropertyCacheBean = getRedisClient().get(key,
				SysPropertyCacheBean.class);
		if (null == sysPropertyCacheBean) {
			// redis未缓存时,调用触发器
			getCacheObjectTrigger().loadSysProperty(propKey);
			sysPropertyCacheBean = getRedisClient().get(key, SysPropertyCacheBean.class);
		}
		return sysPropertyCacheBean;
	}

}
